"""Autogenerated SQLAlchemy models based on OpenAlchemy models."""
# pylint: disable=no-member,super-init-not-called,unused-argument

import typing

import sqlalchemy
from sqlalchemy import orm

from open_alchemy import models


class _RefEmployeeDictBase(typing.TypedDict, total=True):
    """TypedDict for properties that are required."""

    id: int
    name: str
    division: str


class RefEmployeeDict(_RefEmployeeDictBase, total=False):
    """TypedDict for properties that are not required."""

    salary: typing.Optional[float]


class TRefEmployee(typing.Protocol):
    """SQLAlchemy model protocol."""

    # SQLAlchemy properties
    __table__: sqlalchemy.Table
    __tablename__: str
    query: orm.Query

    # Model properties
    id: int
    name: str
    division: str
    salary: typing.Optional[float]

    def __init__(
        self, id: int, name: str, division: str, salary: typing.Optional[float] = None
    ) -> None:
        """Construct."""
        ...

    @classmethod
    def from_dict(
        cls, id: int, name: str, division: str, salary: typing.Optional[float] = None
    ) -> "TRefEmployee":
        """Construct from a dictionary (eg. a POST payload)."""
        ...

    def to_dict(self) -> RefEmployeeDict:
        """Convert to a dictionary (eg. to send back for a GET request)."""
        ...


RefEmployee: TRefEmployee = models.RefEmployee  # type: ignore
