"""Autogenerated SQLAlchemy models based on OpenAlchemy models."""
# pylint: disable=no-member,super-init-not-called,unused-argument

import typing

import sqlalchemy
from sqlalchemy import orm

from open_alchemy import models


class _EmployeeDictBase(typing.TypedDict, total=True):
    """TypedDict for properties that are required."""

    id: int
    name: str
    division: str


class EmployeeDict(_EmployeeDictBase, total=False):
    """TypedDict for properties that are not required."""

    address: typing.Optional[str]
    salary: typing.Optional[float]


class TEmployee(typing.Protocol):
    """SQLAlchemy model protocol."""

    # SQLAlchemy properties
    __table__: sqlalchemy.Table
    __tablename__: str
    query: orm.Query

    # Model properties
    id: int
    name: str
    address: typing.Optional[str]
    division: str
    salary: typing.Optional[float]

    def __init__(
        self,
        id: int,
        name: str,
        division: str,
        address: typing.Optional[str] = None,
        salary: typing.Optional[float] = None,
    ) -> None:
        """Construct."""
        ...

    @classmethod
    def from_dict(
        cls,
        id: int,
        name: str,
        division: str,
        address: typing.Optional[str] = None,
        salary: typing.Optional[float] = None,
    ) -> "TEmployee":
        """Construct from a dictionary (eg. a POST payload)."""
        ...

    def to_dict(self) -> EmployeeDict:
        """Convert to a dictionary (eg. to send back for a GET request)."""
        ...


Employee: TEmployee = models.Employee  # type: ignore
